
import testLoginModule.beans.ProtectedGreeter;

import javax.naming.Context;
import javax.naming.InitialContext;
import java.util.Properties;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;

public class ClientTest {

    public static final String UnprotectedGreeterBean_url = "ejb:/server-login-module-test/UnprotectedGreeterBean!"+ProtectedGreeter.class.getName();
    public static final String ProtectedGreeter_url = "ejb:/server-login-module-test/ProtectedGreeterBean!"+ProtectedGreeter.class.getName();

    public static void main(String[] args)
    {
        System.out.println(UnprotectedGreeterBean_url);
        System.out.println(ProtectedGreeter_url);

        //ClientTest.test_unprotectedBean();
        System.out.print("\n\n\n");
        ClientTest.test_protectedBean_approach_1();


        //ClientTest.test_protectedBean_aproach_2();
    }





    public static void test_protectedBean_approach_1()
    {
        ProtectedGreeter protectedGreeterBean;
        String username = "user1";
        String password = "password";

        final Properties jndiProperties = new Properties();
        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiProperties.put(Context.PROVIDER_URL, "127.0.0.1:4447");

        jndiProperties.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
        jndiProperties.put("remote.connections", "default");
        jndiProperties.put("remote.connection.default.port", "4447");
        jndiProperties.put("remote.connection.default.host", "127.0.0.1");
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");

        jndiProperties.put("jboss.naming.client.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");
        jndiProperties.put("jboss.naming.client.connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");

        // This tels JBOss ejb-client to not use remoting instead of ByPassing
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");
        jndiProperties.put("remote.connection.default.username", "appuser1");
        jndiProperties.put("remote.connection.default.password", "appuser");
        //jndiProperties.put(Context.SECURITY_AUTHENTICATION, "appuser1");
        //jndiProperties.put(Context.SECURITY_CREDENTIALS, "appuser");


        // this is to avoid configur Jboss EJB client API by code instead of jboss-ejb-client.propeties file
        EJBClientConfiguration cc = new PropertiesBasedEJBClientConfiguration(jndiProperties);
        ContextSelector<EJBClientContext> selector = new ConfigBasedEJBClientContextSelector(cc);
        EJBClientContext.setSelector(selector);

        try
        {
            final Context context = new InitialContext(jndiProperties);
            String result_message = "";
            ProtectedGreeter unprotectedGreeterBean = (ProtectedGreeter) context.lookup(UnprotectedGreeterBean_url);
            result_message = unprotectedGreeterBean.tell_me_hello(" Alice");
            System.out.println(result_message);

            protectedGreeterBean = (ProtectedGreeter) context.lookup(ProtectedGreeter_url);
            result_message = protectedGreeterBean.tell_me_hello(" Bob");
            System.out.println(result_message);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }


    public static void test_protectedBean_approach_2()
    {
        ProtectedGreeter protectedGreeterBean;

        String username = "user1";
        String password = "password";
        String CONNECTION = "default";

        final Properties jndiProperties = new Properties();
        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiProperties.put(Context.PROVIDER_URL, "127.0.0.1:4447");

        jndiProperties.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
        jndiProperties.put("remote.connections", "default");
        jndiProperties.put("remote.connection.default.port", "4447");
        jndiProperties.put("remote.connection.default.host", "127.0.0.1");
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");
        jndiProperties.put("remote.connection."+CONNECTION+".connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");
        jndiProperties.put("remote.connection."+CONNECTION+".username", username);
        jndiProperties.put("remote.connection."+CONNECTION+".password",password);

        EJBClientConfiguration cc = new PropertiesBasedEJBClientConfiguration(jndiProperties);
        ContextSelector<EJBClientContext> selector = new ConfigBasedEJBClientContextSelector(cc);
        EJBClientContext.setSelector(selector);


        try
        {
            final Context context = new InitialContext(jndiProperties);
            protectedGreeterBean = (ProtectedGreeter) context.lookup(ProtectedGreeter_url);
            String result_message = "";
            //result_message = protectedGreeterBean.tell_me_hello("novais");
            System.out.print(result_message);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }




    public static void test_unprotectedBean()
    {
        ProtectedGreeter unprotectedGreeterBean;

        final Properties jndiProperties = new Properties();
        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiProperties.put(Context.PROVIDER_URL, "127.0.0.1:4447");

        /*
        remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED=false
        remote.connections=default
        remote.connection.default.host=localhost
        remote.connection.default.port = 4447
        remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS=false
        */

        jndiProperties.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
        jndiProperties.put("remote.connections", "default");
        jndiProperties.put("remote.connection.default.port", "4447");
        jndiProperties.put("remote.connection.default.host", "127.0.0.1");
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");

        // This tels JBOss ejb-client to not use remoting instead of ByPassing
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");

        // username:password is necessary to authenticate the RemoteEJB invocation appuser1 should be in application-users.properties
        // whith following properties:
        /*
        <management>
        ....
            <security-realm name="ApplicationRealm">
                <authentication>
                <properties path="application-users.properties" relative-to="jboss.server.config.dir"/>
                </authentication>
            </security-realm>
        */
        jndiProperties.put("remote.connection.default.username", "appuser1");
        jndiProperties.put("remote.connection.default.password", "appuser");

        EJBClientConfiguration cc = new PropertiesBasedEJBClientConfiguration(jndiProperties);
        ContextSelector<EJBClientContext> selector = new ConfigBasedEJBClientContextSelector(cc);
        EJBClientContext.setSelector(selector);


        try
        {
            final Context context = new InitialContext(jndiProperties);
            unprotectedGreeterBean = (ProtectedGreeter) context.lookup(UnprotectedGreeterBean_url);
            String result_message = unprotectedGreeterBean.tell_me_hello("novais");
            System.out.print(result_message);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }



}
