/**
 * Copyright (C) Portugal Telecom Inovacao S.A., All Rights Reserved.
 *
 * This software is the proprietary information of Portugal Telecom Inovacao S.A.
 * Use is subject to license terms.
 */
package testLoginModule.loginModule;

import java.security.Principal;
import java.security.acl.Group;
import java.util.Map;

import javax.security.auth.Subject;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.login.LoginException;

import org.jboss.security.SimpleGroup;
import org.jboss.security.SimplePrincipal;
import org.jboss.security.auth.spi.UsernamePasswordLoginModule;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class UserPassTestLoginModule extends UsernamePasswordLoginModule
{

	private String login = "";
    private String password = "";
	private Integer userId;
	private Integer profileId = 0;
	private Integer clientId = 0;
	private Integer impersonateId = 0;

	private Boolean impersonated_login = false;

	Principal identity = null;
	

	@Override
	public void initialize(Subject subject, CallbackHandler callbackHandler, Map sharedState, Map options)
	{
		super.initialize(subject, callbackHandler, sharedState, options);
	}

	@Override
	public boolean login() throws LoginException
	{
		System.out.println("UserPassTestLoginModule.login()");
		boolean result = false;
		Callback[] callbacks = new Callback[2];
		callbacks[0] = new NameCallback("user");
		callbacks[1] = new PasswordCallback("credential", false);

		try
		{
            // get Username/Password from CallBack Handlers
			callbackHandler.handle(callbacks);
			login = ((NameCallback) callbacks[0]).getName();
			String password = String.copyValueOf((((PasswordCallback) callbacks[1]).getPassword()));
            System.out.println(String.format("username %s, password %s", login, password));


            // get Username/Password from super UsernamePasswordLoginModule implementation
            String[] username_and_password = super.getUsernameAndPassword();
            String username_ =  username_and_password[0];
            String password_ = username_and_password[1];
            System.out.println(String.format("username '%s', password '%s'",username_, password_));
		}  catch (Exception e)
		{
			e.printStackTrace();
			result = false;			
		}


		//login was ok.
		if ( result == true)
		{
			//get the user Id to store it in CallerId group
			try
			{
				//create jaas identity
				identity = createIdentity(login);
			} catch (Exception ex)
			{
                ex.printStackTrace();
				identity = new SimplePrincipal(login);
			}

			System.out.println(String.format("The user with login: %s, was logged in with success!", login));
		}
		System.out.println(String.format("Returning result = %b", result));
		loginOk = result;
        return loginOk;
	}

	@Override
	public boolean commit() throws LoginException
	{
		return super.commit();
	}

	@Override
	protected Principal getIdentity()
	{		
		return identity;
	}

    @Override
    protected String getUsersPassword() throws LoginException {
        return super.getUsernameAndPassword()[1];
    }

    @Override
	protected Group[] getRoleSets() throws LoginException
	{
		Group[] groups = null;
		return groups;
	}
	
	@Override
	public boolean logout() throws LoginException
	{
		if ( super.logout() == true )
		{
			System.out.println("logout....");
			subject.getPrincipals().clear();
			identity = null;
			login = null;
			return true;
		}
		return false;
	}
	
	
	private Principal createIdentity(String login)
	{
        return new SimplePrincipal(login);
	}
}
